
#import "ApiError.h"
@interface ApiErrors : NSObject
  
// description - Validation error
// message - %s
extern int const validationError;

// description - Unknown business error
// message - Unknown business error
extern int const unknownBusinessError;

// description - Validation error [DEPRECATED], use validationError
// message - %s
extern int const validationErrorCode;

// description - Unknown business error - [DEPRECATED], use unknownBusinessError
// message - Unknown business error
extern int const unknownBusinessErrorCode;

// description - Ipg validation failed
// message - Ipg validation failed
extern int const ipgValidationFailed;

// description - Error for view not found when loading form [add-card, pay-cvv]
// message - View %s not found
extern int const viewNotFoundError;

// description - Curl error when communicating with payment gateway
// message - Curl error
extern int const curlError;

// description - Unknown api error
// message - Unknown api error
extern int const unknownApiError;

// description - libraryNetworkError
// message - %s
extern int const libraryNetworkError;

// description - libraryHttpError
// message - %s
extern int const libraryHttpError;

// description - libraryUnexpectedError
// message - %s
extern int const libraryUnexpectedError;

// description - libraryParsingError
// message - %s
extern int const libraryParsingError;

// description - libraryUnknownError
// message - %s
extern int const libraryUnknownError;

// description - libraryTimeoutError
// message - Timeout occurred after %d seconds
extern int const libraryTimeoutError;

// description - Transaction not found on proxy
// message - Transaction with orderNumber %s not found!
extern int const transactionNotFoundProxy;

// description - Transaction not found on payment gateway
// message - Transaction with orderNumber %s not found!
extern int const transactionNotFoundPgw;

// description - Check order id validation failed
// message - Check order id validation failed
extern int const apiCheckOrderIdValidationFailed;

// description - Term url validation failed. Required fields: [PaRes, MD]
// message - Term url validation failed
extern int const termUrlValidationFailed;

// description - Not authorized, check do you provide auth token.
// message - Not authorized!
extern int const notAuthorized;

// description - Not found, check url!
// message - Not found!
extern int const notFound;

// description - Unknown http exception
// message - HttpException with statusCode: %d and message: %s
extern int const httpException;

// description - Unresolved exception
// message - Unresolved exception with code: %d and message: %s
extern int const unresolvedException;

// description - Transaction not found
// message - Transaction with id: %d not found
extern int const transactionNotFoundId;

// description - Error log not found
// message - Error log with id: %d not found
extern int const errorLogNotFound;

// description - Invalid input data
// message - Invalid input data
extern int const errorLogInvalidData;

  
// description - Validation error
// message - %s
+(ApiError *) validationError: (NSString *) message;
        
// description - Unknown business error
// message - Unknown business error
+(ApiError *) unknownBusinessError: (NSString *) message;
        
// description - Validation error [DEPRECATED], use validationError
// message - %s
+(ApiError *) validationErrorCode: (NSString *) message;
        
// description - Unknown business error - [DEPRECATED], use unknownBusinessError
// message - Unknown business error
+(ApiError *) unknownBusinessErrorCode: (NSString *) message;
        
// description - Ipg validation failed
// message - Ipg validation failed
+(ApiError *) ipgValidationFailed: (NSString *) message;
        
// description - Error for view not found when loading form [add-card, pay-cvv]
// message - View %s not found
+(ApiError *) viewNotFoundError: (NSString *) message;
        
// description - Curl error when communicating with payment gateway
// message - Curl error
+(ApiError *) curlError: (NSString *) message;
        
// description - Unknown api error
// message - Unknown api error
+(ApiError *) unknownApiError: (NSString *) message;
        
// description - libraryNetworkError
// message - %s
+(ApiError *) libraryNetworkError: (NSString *) message;
        
// description - libraryHttpError
// message - %s
+(ApiError *) libraryHttpError: (NSString *) message;
        
// description - libraryUnexpectedError
// message - %s
+(ApiError *) libraryUnexpectedError: (NSString *) message;
        
// description - libraryParsingError
// message - %s
+(ApiError *) libraryParsingError: (NSString *) message;
        
// description - libraryUnknownError
// message - %s
+(ApiError *) libraryUnknownError: (NSString *) message;
        
// description - libraryTimeoutError
// message - Timeout occurred after %d seconds
+(ApiError *) libraryTimeoutError: (NSString *) message;
        
// description - Transaction not found on proxy
// message - Transaction with orderNumber %s not found!
+(ApiError *) transactionNotFoundProxy: (NSString *) message;
        
// description - Transaction not found on payment gateway
// message - Transaction with orderNumber %s not found!
+(ApiError *) transactionNotFoundPgw: (NSString *) message;
        
// description - Check order id validation failed
// message - Check order id validation failed
+(ApiError *) apiCheckOrderIdValidationFailed: (NSString *) message;
        
// description - Term url validation failed. Required fields: [PaRes, MD]
// message - Term url validation failed
+(ApiError *) termUrlValidationFailed: (NSString *) message;
        
// description - Not authorized, check do you provide auth token.
// message - Not authorized!
+(ApiError *) notAuthorized: (NSString *) message;
        
// description - Not found, check url!
// message - Not found!
+(ApiError *) notFound: (NSString *) message;
        
// description - Unknown http exception
// message - HttpException with statusCode: %d and message: %s
+(ApiError *) httpException: (NSString *) message;
        
// description - Unresolved exception
// message - Unresolved exception with code: %d and message: %s
+(ApiError *) unresolvedException: (NSString *) message;
        
// description - Transaction not found
// message - Transaction with id: %d not found
+(ApiError *) transactionNotFoundId: (NSString *) message;
        
// description - Error log not found
// message - Error log with id: %d not found
+(ApiError *) errorLogNotFound: (NSString *) message;
        
// description - Invalid input data
// message - Invalid input data
+(ApiError *) errorLogInvalidData: (NSString *) message;
        

@end