//
//  AddCardViewController.m
//  pay
//
//  Created by Jasmin Suljic on 21/12/16.
//  Copyright © 2016 Webteh.hr. All rights reserved.
//

#import "AddCardViewController.h"
#import "WebtehWebView.h"
#import "PgwApi.h"

@interface AddCardViewController ()
@property (weak, nonatomic) IBOutlet WebtehWebView *webtehWebView;
@property (weak, nonatomic) IBOutlet UIActivityIndicatorView *progressBar;

@end

@implementation AddCardViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    PgwApi *api = [[PgwApi alloc] init:@"00001111222233330000111122223333" isDebug:true];
    NSTimeInterval  today = [[NSDate date] timeIntervalSince1970];
    NSString *orderNumber = [NSString stringWithFormat:@"%.0f", today*1000];
    TransactionLifecycleAdapter * adapter = [[TransactionLifecycleAdapter alloc]
                                             init:self
                                             api:api merchantKey:@"TestKeyXULLyvgWyPJSwOHe"
                                             orderNumber:orderNumber
                                             mode:TRANSACTION_SUCCESS_MODE
                                             ];
    
    [_webtehWebView initialize:adapter isDebug:true timeout:500];
    
    Customer *customer = [[Customer alloc] init:@"John Smith"
                                          email:@"test@test.com"
                                        address:@"Address"
                                    phoneNumber:@"+1-202-555-0138"
                                           city:@"Sarajevo"
                                         userId:@"userIdRandom"
                          ];
    
    Merchant *merchant = [[Merchant alloc] init:@"875322411683"
                            authenticationToken:@"WRPHUBICYDZZRRKPDUNQRDFLUQLRUOJF"
                              authenticityToken: @"caf774914c6965f115f384172ddd67eff277332a"
                                    merchantKey:@"Taxi!123"
                                   clientSecret:@"hgmjw8qs5tuw"
                          ];
    
    OrderDetails *orderDetails = [[OrderDetails alloc]
                                  init:@"1250"
                                  orderNumber:orderNumber
                                  currency:@"EUR"
                                  orderInfo:@"orderInfo"
                                  signature:@"009"
                                  client:@"ios"
                                  ];
    
    AddCardModel *addCardModel = [[AddCardModel alloc] init:merchant orderDetails:orderDetails customer:customer];
    
    [_webtehWebView addCard:addCardModel];
}

-(void) showProgress{
    NSLog(@"showProgress");
    [self.progressBar startAnimating];
}
-(void) hideProgress{
    NSLog(@"hideProgress");
    [self.progressBar stopAnimating];
}

-(void) handleTransactionError: (ApiError *) error{
    NSLog(@"handleTransactionError %@", error);
    [self hideProgress];
}

-(void) transactionSuccess: (TransactionSuccess *) success{
    NSLog(@"transactionSuccess %@", success);
}
    
-(void) logTransactionInfo:(NSString *)loggingInfo {
    NSLog(@"%@", loggingInfo);
}

@end
