#import <Foundation/Foundation.h>
  #import "ApiErrors.h"
  
      // description - Validation error
      // message - %s
      int const validationError = 200000;

      // description - Unknown business error
      // message - Unknown business error
      int const unknownBusinessError = 200001;

      // description - Validation error [DEPRECATED], use validationError
      // message - %s
      int const validationErrorCode = 200000;

      // description - Unknown business error - [DEPRECATED], use unknownBusinessError
      // message - Unknown business error
      int const unknownBusinessErrorCode = 200001;

      // description - Ipg validation failed
      // message - Ipg validation failed
      int const ipgValidationFailed = 200002;

      // description - Error for view not found when loading form [add-card, pay-cvv]
      // message - View %s not found
      int const viewNotFoundError = 200003;

      // description - Curl error when communicating with payment gateway
      // message - Curl error
      int const curlError = 200004;

      // description - Unknown api error
      // message - Unknown api error
      int const unknownApiError = 200005;

      // description - libraryNetworkError
      // message - %s
      int const libraryNetworkError = 200006;

      // description - libraryHttpError
      // message - %s
      int const libraryHttpError = 200007;

      // description - libraryUnexpectedError
      // message - %s
      int const libraryUnexpectedError = 200008;

      // description - libraryParsingError
      // message - %s
      int const libraryParsingError = 200009;

      // description - libraryUnknownError
      // message - %s
      int const libraryUnknownError = 200010;

      // description - libraryTimeoutError
      // message - Timeout occurred after %d seconds
      int const libraryTimeoutError = 200011;

      // description - Transaction not found on proxy
      // message - Transaction with orderNumber %s not found!
      int const transactionNotFoundProxy = 200012;

      // description - Transaction not found on payment gateway
      // message - Transaction with orderNumber %s not found!
      int const transactionNotFoundPgw = 200013;

      // description - Check order id validation failed
      // message - Check order id validation failed
      int const apiCheckOrderIdValidationFailed = 200014;

      // description - Term url validation failed. Required fields: [PaRes, MD]
      // message - Term url validation failed
      int const termUrlValidationFailed = 200015;

      // description - Not authorized, check do you provide auth token.
      // message - Not authorized!
      int const notAuthorized = 200016;

      // description - Not found, check url!
      // message - Not found!
      int const notFound = 200017;

      // description - Unknown http exception
      // message - HttpException with statusCode: %d and message: %s
      int const httpException = 200018;

      // description - Unresolved exception
      // message - Unresolved exception with code: %d and message: %s
      int const unresolvedException = 200019;

      // description - Transaction not found
      // message - Transaction with id: %d not found
      int const transactionNotFoundId = 200020;

      // description - Error log not found
      // message - Error log with id: %d not found
      int const errorLogNotFound = 200021;

      // description - Invalid input data
      // message - Invalid input data
      int const errorLogInvalidData = 200022;

       // description - Transaction in progress
       // message - Transaction in progress
      int const transactionInProgress = 200023;

  @implementation ApiErrors
  
    +(ApiError *) validationError:(NSString *)message{
        return [[ApiError alloc] init:validationError error:message applicationError:true];
     }
    
    +(ApiError *) unknownBusinessError:(NSString *)message{
        return [[ApiError alloc] init:unknownBusinessError error:message applicationError:true];
     }
    
    +(ApiError *) validationErrorCode:(NSString *)message{
        return [[ApiError alloc] init:validationErrorCode error:message applicationError:true];
     }
    
    +(ApiError *) unknownBusinessErrorCode:(NSString *)message{
        return [[ApiError alloc] init:unknownBusinessErrorCode error:message applicationError:true];
     }
    
    +(ApiError *) ipgValidationFailed:(NSString *)message{
        return [[ApiError alloc] init:ipgValidationFailed error:message applicationError:true];
     }
    
    +(ApiError *) viewNotFoundError:(NSString *)message{
        return [[ApiError alloc] init:viewNotFoundError error:message applicationError:true];
     }
    
    +(ApiError *) curlError:(NSString *)message{
        return [[ApiError alloc] init:curlError error:message applicationError:true];
     }
    
    +(ApiError *) unknownApiError:(NSString *)message{
        return [[ApiError alloc] init:unknownApiError error:message applicationError:true];
     }
    
    +(ApiError *) libraryNetworkError:(NSString *)message{
        return [[ApiError alloc] init:libraryNetworkError error:message applicationError:true];
     }
    
    +(ApiError *) libraryHttpError:(NSString *)message{
        return [[ApiError alloc] init:libraryHttpError error:message applicationError:true];
     }
    
    +(ApiError *) libraryUnexpectedError:(NSString *)message{
        return [[ApiError alloc] init:libraryUnexpectedError error:message applicationError:true];
     }
    
    +(ApiError *) libraryParsingError:(NSString *)message{
        return [[ApiError alloc] init:libraryParsingError error:message applicationError:true];
     }
    
    +(ApiError *) libraryUnknownError:(NSString *)message{
        return [[ApiError alloc] init:libraryUnknownError error:message applicationError:true];
     }
    
    +(ApiError *) libraryTimeoutError:(NSString *)message{
        return [[ApiError alloc] init:libraryTimeoutError error:message applicationError:true];
     }
    
    +(ApiError *) transactionNotFoundProxy:(NSString *)message{
        return [[ApiError alloc] init:transactionNotFoundProxy error:message applicationError:true];
     }
    
    +(ApiError *) transactionNotFoundPgw:(NSString *)message{
        return [[ApiError alloc] init:transactionNotFoundPgw error:message applicationError:true];
     }
    
    +(ApiError *) apiCheckOrderIdValidationFailed:(NSString *)message{
        return [[ApiError alloc] init:apiCheckOrderIdValidationFailed error:message applicationError:true];
     }
    
    +(ApiError *) termUrlValidationFailed:(NSString *)message{
        return [[ApiError alloc] init:termUrlValidationFailed error:message applicationError:true];
     }
    
    +(ApiError *) notAuthorized:(NSString *)message{
        return [[ApiError alloc] init:notAuthorized error:message applicationError:true];
     }
    
    +(ApiError *) notFound:(NSString *)message{
        return [[ApiError alloc] init:notFound error:message applicationError:true];
     }
    
    +(ApiError *) httpException:(NSString *)message{
        return [[ApiError alloc] init:httpException error:message applicationError:true];
     }
    
    +(ApiError *) unresolvedException:(NSString *)message{
        return [[ApiError alloc] init:unresolvedException error:message applicationError:true];
     }
    
    +(ApiError *) transactionNotFoundId:(NSString *)message{
        return [[ApiError alloc] init:transactionNotFoundId error:message applicationError:true];
     }
    
    +(ApiError *) errorLogNotFound:(NSString *)message{
        return [[ApiError alloc] init:errorLogNotFound error:message applicationError:true];
     }
    
    +(ApiError *) errorLogInvalidData:(NSString *)message{
        return [[ApiError alloc] init:errorLogInvalidData error:message applicationError:true];
     }
    
  @end
