//
//  BusinessError.m
//  Pods
//
//  Created by Jasmin Suljic on 07/02/17.
//
//

#import <Foundation/Foundation.h>
#import "BusinessError.h"

@implementation BusinessError

+(ApiError *) fromJson: (NSDictionary *) jsonDict{
    
    if (!jsonDict) {
        return nil;
    } else {
        
        int transactionId = [jsonDict objectForKey:@"transaction_id"] ? [[jsonDict valueForKey:@"transaction_id"] intValue]: -1;
        
        NSString* fullName =  [TransactionSuccess nilOrValue:[jsonDict objectForKey:@"full_name"]];
        NSString* cardType = [TransactionSuccess nilOrValue:[jsonDict objectForKey:@"card_type"]];
        NSString* maskedPan = [TransactionSuccess nilOrValue:[jsonDict objectForKey:@"masked_pan"]];
        NSString* pmAlias = [TransactionSuccess nilOrValue:[jsonDict objectForKey:@"pm_alias"]];
        
        if (transactionId == -1 || fullName == nil || cardType == nil || maskedPan == nil) {
            return nil;
        }
        
        BusinessError* error = [[BusinessError alloc] init:[[jsonDict valueForKey:@"code"] intValue] error:[jsonDict valueForKey:@"error"]];
        error.definiteError = [jsonDict objectForKey:@"definite_error"] ? [[jsonDict valueForKey:@"definite_error"] boolValue]: false;
        error.applicationError = [jsonDict objectForKey:@"library_error"] ? [[jsonDict valueForKey:@"library_error"] boolValue]: false;
        error.errorId = [jsonDict objectForKey:@"error_id"] ? [[jsonDict valueForKey:@"error_id"] intValue]: -1;
        error.fullName = fullName;
        error.cardType = cardType;
        error.maskedPan = maskedPan;
        error.pmAlias = pmAlias;
        error.transactionId = transactionId;
        return error;
    }
}

-(NSString *) description{
    return [NSString stringWithFormat:@"BusinessError: {code: %d, error: %@, library_error: %d, definite_error: %d, error_id: %d, transactionId: %d, fullName: %@, cardType: %@, maskedPan: %@, pmAlias: %@}", self.code, self.error, self.applicationError, self.definiteError, self.errorId, self.transactionId, self.fullName, self.cardType, self.maskedPan, self.pmAlias];
}


@end
