//
//  InputResolver.m
//  pay
//
//  Created by Jasmin Suljic on 22/12/16.
//  Copyright © 2016 Webteh.hr. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "InputResolver.h"

@implementation InputResolver

// Returns '' if encoding fails
+(NSString *) encode:(NSMutableDictionary *)data{
    NSError *error;
    NSData *jsonData = [NSJSONSerialization dataWithJSONObject:data
                                                       options:0
                                                         error:&error];
    if (! jsonData) {
        return @"";
    } else {
        
        NSString *base64String = [jsonData base64EncodedStringWithOptions:0];
        base64String = [base64String stringByReplacingOccurrencesOfString:@"/" withString:@"_"];
        base64String = [base64String stringByReplacingOccurrencesOfString:@"+" withString:@"-"];
        return base64String;
    }
}

// Returns empty dictionary if decodins fails
+(NSDictionary *) decode:(NSString *)input {
    input = [input stringByReplacingOccurrencesOfString:@"_" withString:@"/"];
    input = [input stringByReplacingOccurrencesOfString:@"-" withString:@"+"];
    
    NSUInteger paddedLength = input.length + (4 - (input.length % 4 == 0 ? 4: input.length % 4));
    NSString* correctBase64String = [input stringByPaddingToLength:paddedLength withString:@"=" startingAtIndex:0];
    NSData *decodedData = [[NSData alloc] initWithBase64EncodedString:correctBase64String options:0];
    
    if (!decodedData) {
        return [[NSDictionary alloc] init];
    }
    
    NSError *error;
    NSDictionary *jsonDict = [NSJSONSerialization JSONObjectWithData:decodedData options:0 error:&error];
    
    if (!jsonDict) {
        return [[NSDictionary alloc] init];
    }else{
        return jsonDict;
    }
}

@end
