//
//  PayModel.m
//  pay
//
//  Created by Jasmin Suljic on 28/09/15.
//  Copyright © 2015 Leftor d.o.o. All rights reserved.
//

#import "PayModel.h"
#import <CommonCrypto/CommonDigest.h>

@implementation PayModel

+ (NSDictionary *) mapping{
    return @{
             @"merchantId.text": @"merchantId",
             @"amount.text": @"amount",
             @"currency.text": @"currency",
             @"order_number.text": @"order_number",
             @"payment_method.text": @"paymentMethod",
             @"pm_alias.text": @"pm_alias",
             @"expiry.text": @"expiry",
             @"digest.text": @"digest",
             @"sign.text": @"sign"
             };
}

+(NSDictionary *) mapForRequest{
    return @{
             @"merchantId": @"merchantId",
             @"amount": @"amount",
             @"currency": @"currency",
             @"order_number": @"order_number",
             @"payment_method": @"payment_method",
             @"pm_alias": @"pm_alias",
             @"expiry": @"expiry",
             @"digest": @"digest",
             @"sign": @"sign"
             };
}

+(NSString*) sha1:(NSString*)input
{
    const char *cstr = [input cStringUsingEncoding:NSUTF8StringEncoding];
    NSData *data = [NSData dataWithBytes:cstr length:input.length];
    
    uint8_t digest[CC_SHA1_DIGEST_LENGTH];
    
    CC_SHA1(data.bytes, data.length, digest);
    
    NSMutableString* output = [NSMutableString stringWithCapacity:CC_SHA1_DIGEST_LENGTH * 2];
    
    for(int i = 0; i < CC_SHA1_DIGEST_LENGTH; i++)
        [output appendFormat:@"%02x", digest[i]];
    
    return output;
}

-(void)generateDigest{
    NSString *tmp =[NSString stringWithFormat:@"%@%@%@%@%@",_merchantId, _order_number, _amount,_currency, _clientSecret];
    _digest = [tmp SHA1];
}
@end
